local Queue = {}
Queue.__index = Queue

function Queue:new(max_size)
    return setmetatable({max_size = max_size or 20, start = 1, finish = 0, data = {}}, self)
end

function Queue:push(value)
    self.finish = self.finish + 1
    self.data[self.finish] = value
    
    if self.finish - self.start + 1 > self.max_size then
        self.data[self.start] = nil
        self.start = self.start + 1
    end
end

function Queue:contains(value)
    for i = self.start, self.finish do
        if self.data[i] == value then
            return true
        end
    end
    return false
end

return Queue
